// -*- C++ -*-
//===----------------------------------------------------------------------===//
//
// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.
// See https://llvm.org/LICENSE.txt for license information.
// SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
//
//===----------------------------------------------------------------------===//

#ifndef _LIBCPP___CXX03_TGMATH_H
#define _LIBCPP___CXX03_TGMATH_H

/*
    tgmath.h synopsis

#include <__cxx03/ctgmath>

*/

#include <__cxx03/__config>

#if !defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)
#  pragma GCC system_header
#endif

#ifdef __cplusplus
#  include <__cxx03/ctgmath>
#else
#  if __has_include_next(<tgmath.h>)
#    include_next <tgmath.h>
#  endif
#endif

#endif // _LIBCPP___CXX03_TGMATH_H
